From 46d2c02dac9af513b41c82a88d6fbc325ebde1a2 Mon Sep 17 00:00:00 2001
From: Daniel Pimentel <d4n1@member.fsf.org>
Date: Mon, 14 Dec 2015 12:04:45 -0300
Subject: [PATCH 4/4] gnu: update gpl-faq.pt-br.po * translate to line 3025
 (45%)

---
 licenses/gpl-faq.pt-br.po | 97 ++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 96 insertions(+), 1 deletion(-)

diff --git a/licenses/gpl-faq.pt-br.po b/licenses/gpl-faq.pt-br.po
index 95a8537..205d612 100644
--- a/licenses/gpl-faq.pt-br.po
+++ b/licenses/gpl-faq.pt-br.po
@@ -2097,6 +2097,15 @@ msgid ""
 "\"#GPLOutput\">requirement on the output of software</a>, regardless of "
 "whether it is licensed under the terms of the GPL or some other license."
 msgstr ""
+"Não, isso não é permitido sob os termos da GPL. Enquanto nós reconhecemos "
+"que a citação proposta é uma importante parte de publicações acadêmcias, citação "
+"não pode ser adicionada como um requisito adicional da GPL. Requisição de citação "
+"em pesquisas que faz uso de software GPL qye vão além de "
+"ser aceito por requerimentos adicionais sob a seção 7(b) de GPLv3, e "
+"portanto seria considerado uma renstrinção adicional sob Seção 7 da "
+"GPL. e a lei de copyright não permite você colocar tais <a href="
+"\"#GPLOutput\">requierimentos na saída de software</a>, independentemente de "
+"se ele está sob os termos da GPL ou alguma outra licença."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -2171,12 +2180,20 @@ msgid ""
 "must have put the copy of the GNU GPL there because you wanted to license "
 "the code that way.  But why leave any uncertainty?"
 msgstr ""
+"Um arquivo contendo só a licença, sem uma afirmação que afirma que outros "
+"arquivo são cobertos por essa licença, se assemelha a um arquivo contendo só uma "
+"subroutina que nunca é chamada de outro lugar. A semelhança não é "
+"perfeita: advogados e tribunais devem aplicar o senso comum e concluir que você "
+"deve colocar a cópia do GNU GPL lá porque você procuraa licença "
+"do código de qualquer forma. Mas porque deixar qualquer incerteza?"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
 "This has nothing to do with the specifics of the GNU GPL.  It is true for "
 "any free license."
 msgstr ""
+"Não tem o que fazer com especificas da GNU GPL. É verdade para "
+"qualquer licença livree."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -2184,6 +2201,9 @@ msgid ""
 "reference-id\">(<a href=\"#NoticeInSourceFile\" >#NoticeInSourceFile</a>)</"
 "span>"
 msgstr ""
+"Porque eu devo colocar um aviso de licença em cada arquivo fonte? <span class=\"anchor-"
+"reference-id\">(<a href=\"#NoticeInSourceFile\" >#NoticeInSourceFile</a>)</"
+"span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -2196,12 +2216,22 @@ msgid ""
 "license-list.html#NoLicense\">no license at all</a> (which would make the "
 "code nonfree)."
 msgstr ""
+"Você deve colocar um aviso inicial em cada arquivo fonte, declarando que "
+"o que a licença traz, em ordem para evitar o risco de pegar o código "
+"disconectado da licença.  Se seu repositório tem o arquivo README dizendo que o arquivo "
+"fonte está sob a GNU GPL, o que acontece se alguém copiar aquele arquivo para "
+"outros rogramas? Em outro contexto pode não mostrar em qual licença aquele arquivo "
+"está. Pode aparecer outro tipo de licença, ou <a href=\"/licenses/"
+"license-list.html#NoLicense\">nenhum licença</a> (que deve fazer o "
+"código não livre)."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
 "Adding a copyright notice and a license notice at the start of each source "
 "file is easy and makes such confusion unlikely."
 msgstr ""
+"Adicionando um aviso de copyright e uma nota de licença notice do início de cada arquivo "
+"fonte é fácil e faz cada confusão improvável."
 
 #. type: Content of: <dl><dt>
 #, fuzzy
@@ -2301,6 +2331,9 @@ msgid ""
 "not necessary that their licenses be compatible, because this does not "
 "combine them into a larger work."
 msgstr ""
+"Se você só quer instalar dois programas separados no mesmo sistema, não é "
+"necessário que as licenças deles sejam compatíveis, porque isso não "
+"combina que inicia um grande trabalhok."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -2341,6 +2374,10 @@ msgid ""
 "that are not in GPLv3 itself.  Section 7 has more information about this, "
 "including the list of additional requirements that are permitted."
 msgstr ""
+"GPLv3 é compatível com mais licenças que GPLv2: permitindo que você faça "
+"combinações com código que tem especificado tipos de requisitos adicionais "
+"que não estão em GPLv3 por si mesma.  Seção 7 tem mais informações sobre isso, "
+"incluindo a lista de requisitos adicionais que são permitidos."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -2411,6 +2448,9 @@ msgid ""
 "\"anchor-reference-id\">(<a href=\"#SystemLibraryException"
 "\">#SystemLibraryException</a>)</span>"
 msgstr ""
+"Eu posso linkar um programa GPL com uma biblioteca de sistema proprietário? <span class="
+"\"anchor-reference-id\">(<a href=\"#SystemLibraryException"
+"\">#SystemLibraryException</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -2421,6 +2461,12 @@ msgid ""
 "for the whole program does not include those libraries, even if you "
 "distribute a linked executable containing them."
 msgstr ""
+"Ambos as versões da GPL tem uma execção para o copyleft, geralmente "
+"chamado de execção de biblioteca do sistema. Se a biblioteca é imcompatível com a GPL e você "
+"deseja usar o critério para a biblioteca do sistema, então você não tem "
+"que fazer nada especial para usá-la; o requsito para distribuir o código fonte "
+"para o programa todo não inclui essas bibliotecas, sempre se você "
+"distribuir um link executável que contenha-o."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -2430,6 +2476,11 @@ msgid ""
 "Corresponding Source.&quot; GPLv2 deals with this issue slightly "
 "differently, near the end of section 3."
 msgstr ""
+"Os criterios que contam como uma &quot;biblioteca do sistema&quot; variam entre "
+"diferente versões da GPL.  GPLv3 define explicitamente &quot;Biblioteca "
+"de Sistema&quot; na seção 1, excluindo-o da definição de &quot;"
+"Código Correspondente.&quot; GPLv2 promove com essa questão levemente "
+"diferente, próximo do fim da seção 3."
 
 #. type: Content of: <dl><dt>
 #, fuzzy
@@ -2450,6 +2501,11 @@ msgid ""
 "other for GPLv2.  In either case, you should put this text in each file to "
 "which you are granting this permission."
 msgstr ""
+"Se você quer que seu programa link uma biblioteca não coberta pela execção do sistema, "
+"você precisa prover permissão para fazer isso. Abaixo tem dois "
+"exemplo de aviso de licença que você pode usar para fazer isso; uma para GPLv3, e a "
+"outra para GPLv2. No outro caso, você pode colocar esse texto em cada arquivo para "
+"que você garanta essa permissão."
 
 #. type: Content of: <dl><dd><p>
 #, fuzzy
@@ -2499,6 +2555,12 @@ msgid ""
 "the libraries you intend to link with, you should remove the text in braces; "
 "otherwise, just remove the braces themselves."
 msgstr ""
+"Se você está usando GPLv3, você pode realizar esse objetivo para garantir uma "
+"permissão adicional sob a seção 7.  O sequinte aviso de licença fará "
+"isso.  Você pode substituir todo o texto nos colchetes como texto que é "
+"apropriado para seu programa.  Se ninguém pode distribuir o fonte para "
+"a biblioteca que você tentou linkar, você deve remover o texto nos colchetes; "
+"caso contrário, só remova o colchete de si mesmo."
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid "Copyright (C) <var>[years]</var> <var>[name of copyright holder]</var>"
@@ -2539,7 +2601,7 @@ msgstr ""
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid "Additional permission under GNU GPL version 3 section 7"
-msgstr ""
+msgstr "Permissão adicional sob GNU GPL versão 3 seção 7"
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid ""
@@ -2551,6 +2613,13 @@ msgid ""
 "such a combination shall include the source code for the parts of <var>[name "
 "of library]</var> used as well as that of the covered work.}"
 msgstr ""
+"Se você modificar esse Programa, ou qualquer trabalho relacionado, por linkagem our combinação dele "
+"com <var>[nome da biblioteca]</var> (our uma versão modificada da biblioteca), "
+"contendo partes coberta pelos termos de <var>[nome da licença da biblioteca]</"
+"var>, os licenciadores desse Programa permite que você adicione permissão para "
+"transmitir o resultado do trabalho.  {Correspondente ao Fonte para o não fonte de fomra que "
+"cada combinação deve incluir o código fonte para as partes de <var>[nome "
+"da biblioteca]</var> usada como bem que o trabalho permite.}"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -2561,6 +2630,12 @@ msgid ""
 "with, you should remove the text in braces; otherwise, just remove the "
 "braces themselves."
 msgstr ""
+"Se você está usando a GPLv2, você pode prover sua própria exceção para os termos "
+"da licença.  O seguinte aviso de licença irá fazé-lo. Novamente, você deve substituir "
+"todo o texto nos colchetes como texto que seja mais apropriado para seu programa.  Se "
+"ninguém pode distribuir o fonte para suas bibliotecas você pode linkar com "
+"ela, você deve remover o texto nos colchetes; por outro lado, só remova os "
+"colchetes dele mesmo."
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid ""
@@ -2581,6 +2656,10 @@ msgid ""
 "program]</var>.  Thus, the terms and conditions of the GNU General Public "
 "License cover the whole combination."
 msgstr ""
+"Linkando <var>[nome de seu programa]</var> staticamente ou dynamicamente com "
+"outros módulos está fazendo um trabalho combinado baseado no <var>[nome de seu "
+"programa]</var>.  Assim, os termos e condições de sua GNU General Public "
+"License cobri a combinação toda."
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid ""
@@ -2595,6 +2674,16 @@ msgid ""
 "concerned{, provided that you include the source code of that other code "
 "when and as the GNU GPL requires distribution of source code}."
 msgstr ""
+"Em adição, como execção especial, os titulares do copyright de <var>[nome de "
+"seu programa]</var> dão a você permissão para combinar <var>[nome de seu "
+"programa]</var> com os programas de software livre ou bibliotecas que são lançadas "
+"sob a GNU LGPL e com código incluído no lançamento padrão de "
+"<var>[nome da biblioteca]</var> sob o <var>[nome da licença da biblioteca]</"
+"var> (or versões modificadas do código, com a licença inalterada).  Você pode "
+"copiar e distribuir o sistema segundo os termos da GNU GPL para "
+"<var>[nome de seu programa]</var> e as licenças do outro código "
+"concedido{, provido que você inclua o código fonte do outro código "
+"quando e como a GNU GPL requer distribuição de seu código fonte}."
 
 #. type: Content of: <dl><dd><blockquote><p>
 msgid ""
@@ -2605,6 +2694,12 @@ msgid ""
 "exception; this exception also makes it possible to release a modified "
 "version which carries forward this exception."
 msgstr ""
+"Note que pessoasl que fazer versões modificadas de <var>[nome de seu programa]</"
+"var> não são obrigadas a garantir execções especiais para essas versões "
+"modificadas; depende das condições deles fazer isso.  A GNU General Public "
+"License dá permissão para lançar versões modificadas sem essa "
+"execção; essa execção também faz possível lançar versão "
+"modificada que carrega adiante essa exceção."
 
 #. type: Content of: <dl><dt>
 msgid ""
-- 
2.5.0