From f7e874d954ab0e47c8528bd0aab5cfe47378e6e5 Mon Sep 17 00:00:00 2001
From: Maxim Cournoyer <maxim.cournoyer@gmail.com>
Date: Wed, 14 Jun 2023 21:23:29 -0400
Subject: [PATCH 6/6] new rounds of changes on re-run

sed 's/_au_m4_changequote(\[,\])//g' -i configure.in
---
 configure.in | 131 ++++++++++++++++++---------------------------------
 1 file changed, 47 insertions(+), 84 deletions(-)

diff --git a/configure.in b/configure.in
index bdb533946e..9d49a35876 100644
--- a/configure.in
+++ b/configure.in
@@ -1410,15 +1410,13 @@ case "${host}" in
     AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <CoreFoundation/CFBase.h>
 ]], [[]])],[AC_MSG_RESULT([yes])],[AC_MSG_RESULT([no])
         AC_MSG_CHECKING([if __CF_USE_FRAMEWORK_INCLUDES__ is required])
-        AC_TRY_COMPILE([#define __CF_USE_FRAMEWORK_INCLUDES__
+        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#define __CF_USE_FRAMEWORK_INCLUDES__
 #include <CoreFoundation/CFBase.h>
-        ],[],
-        [AC_MSG_RESULT([yes])
+        ]], [[]])],[AC_MSG_RESULT([yes])
         dnl We must use -D so source files that don't include wx/setup.h
         dnl but do include CFBase will work.
-        CPPFLAGS="-D__CF_USE_FRAMEWORK_INCLUDES__ $CPPFLAGS"],
-        [AC_MSG_FAILURE([no.  CoreFoundation not available.])]
-        )
+        CPPFLAGS="-D__CF_USE_FRAMEWORK_INCLUDES__ $CPPFLAGS"],[AC_MSG_FAILURE([no.  CoreFoundation not available.])
+        ])
         
     ])
   ;;
@@ -3426,9 +3424,7 @@ if test "$wxUSE_SHARED" = "yes"; then
                 AC_MSG_RESULT([no])
                 AC_MSG_CHECKING([if the linker accepts -R])
                 LDFLAGS="$saveLdflags -Wl,-R,/"
-                AC_TRY_LINK(
-                    [],[],
-                    [
+                AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [[]])],[
                         AC_MSG_RESULT([yes])
                         SAMPLES_RPATH_FLAG="-Wl,-R,\$(wx_top_builddir)/lib"
                         WXCONFIG_RPATH="-Wl,-R,\$libdir"
@@ -3917,21 +3913,17 @@ if test "$wx_cv_func_statvfs" = "yes"; then
                 l += fs.f_blocks;
                 l += fs.f_bavail;
             ]])],[wx_cv_type_statvfs_t=statvfs_t],[
-                AC_TRY_COMPILE(
-                    [
+                AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                         #include <sys/statvfs.h>
-                    ],
-                    [
+                    ]], [[
                         long l;
                         struct statvfs fs;
                         statvfs("/", &fs);
                         l = fs.f_bsize;
                         l += fs.f_blocks;
                         l += fs.f_bavail;
-                    ],
-                    wx_cv_type_statvfs_t="struct statvfs",
-                    wx_cv_type_statvfs_t="unknown"
-                )
+                    ]])],[wx_cv_type_statvfs_t="struct statvfs"],[wx_cv_type_statvfs_t="unknown"
+                ])
             
         ])
         AC_LANG_POP()]
@@ -5003,19 +4995,16 @@ if test "$USE_UNIX" = 1 ; then
             ]])],[ac_cv_header_sys_soundcard=yes],[
                 saveLibs="$LIBS"
                 LIBS="$saveLibs -lossaudio"
-                AC_TRY_LINK([
+                AC_LINK_IFELSE([AC_LANG_PROGRAM([[
                         #include <sys/ioctl.h>
                         #include <sys/soundcard.h>
-                    ],
-                    [
+                    ]], [[
                         ioctl(0, SNDCTL_DSP_SPEED, 0);
-                    ],
-                    ac_cv_header_sys_soundcard=yes,
-                    [
+                    ]])],[ac_cv_header_sys_soundcard=yes],[
                         LIBS="$saveLibs"
                         ac_cv_header_sys_soundcard=no
-                    ]
-                )
+                    
+                ])
             
         ])
     ])
@@ -5437,21 +5426,17 @@ if test "$ac_cv_func_gettimeofday" = "yes"; then
             ]], [[
                 struct timeval tv;
                 gettimeofday(&tv, NULL);
-            ]])],[wx_cv_func_gettimeofday_has_2_args=yes],[AC_TRY_COMPILE(
-                 [
+            ]])],[wx_cv_func_gettimeofday_has_2_args=yes],[AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                      #include <sys/time.h>
                      #include <unistd.h>
-                 ],
-                 [
+                 ]], [[
                      struct timeval tv;
                      gettimeofday(&tv);
-                 ],
-                 wx_cv_func_gettimeofday_has_2_args=no,
-                 [
+                 ]])],[wx_cv_func_gettimeofday_has_2_args=no],[
                      AC_MSG_WARN([failed to determine number of gettimeofday() arguments])
                      wx_cv_func_gettimeofday_has_2_args=unknown
-                 ]
-            )
+                 
+            ])
         ])
     ])
 
@@ -5475,37 +5460,29 @@ if test "$wxUSE_DATETIME" = "yes"; then
                             ]])],[
                                 wx_cv_var_timezone=timezone
                             ],[
-                                AC_TRY_COMPILE(
-                                    [
+                                AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                         #include <time.h>
-                                    ],
-                                    [
+                                    ]], [[
                                         int tz;
                                         tz = _timezone;
-                                    ],
-                                    [
+                                    ]])],[
                                         wx_cv_var_timezone=_timezone
-                                    ],
-                                    [
-                                        AC_TRY_COMPILE(
-                                            [
+                                    ],[
+                                        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                                 #include <time.h>
-                                            ],
-                                            [
+                                            ]], [[
                                                 int tz;
                                                 tz = __timezone;
-                                            ],
-                                            [
+                                            ]])],[
                                                 wx_cv_var_timezone=__timezone
-                                            ],
-                                            [
+                                            ],[
                                                 if test "$USE_DOS" = 0 ; then
                                                     AC_MSG_WARN(no timezone variable, will use tm_gmtoff instead)
                                                 fi
-                                            ]
-                                        )
-                                    ]
-                                )
+                                            
+                                        ])
+                                    
+                                ])
                             
                         ])
                         AC_LANG_POP()
@@ -5628,29 +5605,22 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                             CFLAGS="-Werror $CFLAGS"
                         fi
 
-                        AC_TRY_COMPILE(
-                            [
+                        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                 #include <sys/types.h>
                                 #include <sys/socket.h>
-                            ],
-                            [
+                            ]], [[
                                 size_t len;
                                 getsockname(0, 0, &len);
-                            ],
-                            wx_cv_type_getsockname3=size_t, [
-                            AC_TRY_COMPILE(
-                                [
+                            ]])],[wx_cv_type_getsockname3=size_t],[
+                            AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                     #include <sys/types.h>
                                     #include <sys/socket.h>
-                                ],
-                                [
+                                ]], [[
                                     int len;
                                     getsockname(0, 0, &len);
-                                ],
-                                wx_cv_type_getsockname3=int,
-                                wx_cv_type_getsockname3=unknown
-                            )]
-                        )
+                                ]])],[wx_cv_type_getsockname3=int],[wx_cv_type_getsockname3=unknown
+                            ])
+                        ])
 
                         CFLAGS="$CFLAGS_OLD"
                     
@@ -5681,29 +5651,22 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                         socklen_t len;
                         getsockopt(0, 0, 0, 0, &len);
                     ]])],[wx_cv_type_getsockopt5=socklen_t],[
-                        AC_TRY_COMPILE(
-                            [
+                        AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                 #include <sys/types.h>
                                 #include <sys/socket.h>
-                            ],
-                            [
+                            ]], [[
                                 size_t len;
                                 getsockopt(0, 0, 0, 0, &len);
-                            ],
-                            wx_cv_type_getsockopt5=size_t, [
-                            AC_TRY_COMPILE(
-                                [
+                            ]])],[wx_cv_type_getsockopt5=size_t],[
+                            AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
                                     #include <sys/types.h>
                                     #include <sys/socket.h>
-                                ],
-                                [
+                                ]], [[
                                     int len;
                                     getsockopt(0, 0, 0, 0, &len);
-                                ],
-                                wx_cv_type_getsockopt5=int,
-                                wx_cv_type_getsockopt5=unknown
-                            )]
-                        )
+                                ]])],[wx_cv_type_getsockopt5=int],[wx_cv_type_getsockopt5=unknown
+                            ])
+                        ])
                     
                 ])
                 AC_LANG_POP()
-- 
2.40.1